"""
This is a modifed version of the graph module from the exercise material.

The shortest path algorithm has been factored out and the Graph class was removed.
The Node and Edge classes have not been modified, so there is still room for improvement :-).
"""


class Node(object):
    """Base class for nodes.

    To add additional data attributes to nodes you can derive subclasses.
    """

    def __init__(self):
        self._out_edges = []  # outgoing edges

    @property
    def out_edges(self):
        return self._out_edges


class Edge(object):
    """Class representing a directed edge connection between two nodes."""

    def __init__(self, head, tail):
        """
        head, tail -- The end and starting node of this edge, or can be None.
        """
        self._head = head
        self._tail = tail
        tail._out_edges.append(self)

    @property
    def head(self):
        return self._head

    @property
    def tail(self):
        return self._tail
